## knot-resolver-6.0.7.tar.xz

=== meson_options.txt ===
# Configuration options
# SPDX-License-Identifier: GPL-3.0-or-later

option(
  'keyfile_default',
  type: 'string',
  value: 'root.keys',
  description: 'built-in path to DNSSEC trust anchors file',
)

option(
  'managed_ta',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'auto-manage DNSSEC trust anchors (RFC 5011)',
)

option(
  'root_hints',
  type: 'string',
  value: 'root.hints',
  description: 'built-in path to root.hints file',
)

option(
  'install_kresd_conf',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'disabled',
  description: 'creates kresd.conf in config directory (legacy for version before 6)',
)

option(
  'install_root_keys',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'installs DNSSEC TA to keyfile_default location',
)

option(
  'user',
  type: 'string',
  value: 'knot-resolver',
  description: 'user which is used for running kresd',
)

option(
  'group',
  type: 'string',
  value: 'knot-resolver',
  description: 'group which is used for running kresd',
)

option(
  'sendmmsg',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'use sendmmsg syscall towards clients',
)

option(
  'capng',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'use libcapng to drop capabilities for non-root users',
)

## Systemd
option(
  'systemd_files',
  type: 'combo',
  choices: [
    'disabled',
    'enabled',
  ],
  value: 'disabled',
  description: 'installs systemd-related files',
)

option(
  'systemd_legacy_units',
  type: 'combo',
  choices: [
    'disabled',
    'enabled',
  ],
  value: 'disabled',
  description: 'installs legacy systemd units for running without manager, like with versions before 6',
)

# Component options
option(
  'bench',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'disabled',
  description: 'build benchmarks',
)

option(
  'manager',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'disabled',
  description: 'build manager and its features',
)

option(
  'utils',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'build kres utilities',
)

option(
  'dnstap',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'build dnstap module',
)

option(
  'malloc',
  type: 'combo',
  choices: [
    'auto',     # 'jemalloc' if available
    'disabled', # default provided by libc
    'jemalloc',
  ],
  value: 'auto',
  description: 'memory allocator to use in kresd',
)

option(
  'doc',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'disabled',
  description: 'html documentation dependencies and installation',
)

option(
  'kres_gen_test',
  type: 'boolean',
  value: true,
  description: 'run kres_gen_test: a simple sanity check for our lua bindings',
)

option(
  'config_tests',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'postinstall config tests',
)

option(
  'extra_tests',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'disabled',
  description: 'postinstall tests with extra dependencies',
)

option(
  'unit_tests',
  type: 'combo',
  choices: [
    'auto',
    'enabled',
    'disabled',
  ],
  value: 'auto',
  description: 'cmocka unit tests',
)

=== distro/pkg/arch/PKGBUILD ===
# Maintainer:	Tomas Krizek <tomas.krizek@nic.cz>
# Contributor:	Ondřej Surý <ondrej@sury.org>
# SPDX-License-Identifier: GPL-3.0-or-later

pkgname=knot-resolver
pkgver={{ version }}
pkgrel={{ release }}
pkgdesc='Caching DNSSEC-validating DNS resolver'
arch=('x86_64' 'armv7h')
url='https://www.knot-resolver.cz/'
license=('GPL3')
depends=(
    'dnssec-anchors'
    'gnutls'
    'knot'
    'libedit'
    'libuv'
    'lmdb'
    'luajit'
    'systemd'
    'libcap-ng'
    'libnghttp2'
    'jemalloc'
    'python'
    'python-yaml'
    'python-aiohttp'
    'python-typing-extensions'
    'python-prometheus_client'
    'python-typing-extensions'
    'python-jinja'
    'supervisor'
)
makedepends=(
    'cmocka'
    'meson'
    'systemd-libs'
    'python-build'
    'python-installer'
    'python-poetry'
)
optdepends=(
    'lua51-basexx: experimental_dot_auth module'
    'lua51-cqueues: http and dns64 module, policy.rpz() function'
    'lua51-http: http and prefill modules, trust_anchors bootstrap'
    'lua51-psl: policy.slice_randomize_psl() function'
)
backup=('etc/knot-resolver/kresd.conf')
options=(debug strip)
source=("knot-resolver-${pkgver}.tar.xz")
sha256sums=('SKIP')

build() {
    cd "${srcdir}/${pkgname}-${pkgver}"
    meson setup build \
        --buildtype=release \
        --prefix=/usr \
        --sbindir=bin \
        -D keyfile_default=/etc/trusted-key.key \
        -D systemd_files=enabled \
        -D malloc=jemalloc \
        -D unit_tests=enabled
    ninja -C build
    pushd build/python
    python -Pm build --wheel --no-isolation
    popd
    pushd manager
    python -Pm build --wheel --no-isolation
    popd
}

check() {
    cd "${srcdir}/${pkgname}-${pkgver}"
    meson test -C build
}

package() {
    cd "${srcdir}/${pkgname}-${pkgver}"
    DESTDIR=${pkgdir} ninja -C build install

    # add knot-resolver.service to multi-user.target.wants to support enabling the service
    install -d -m 0755 "${pkgdir}/usr/lib/systemd/system/multi-user.target.wants"
    ln -s ../knot-resolver.service ${pkgdir}/usr/lib/systemd/system/multi-user.target.wants/knot-resolver.service

    # remove modules with missing dependencies
    rm "${pkgdir}/usr/lib/knot-resolver/kres_modules/etcd.lua"

    # install knot-resolver metadata Python module
    pushd build/python
    python -Pm installer --destdir="$pkgdir" dist/*.whl
    popd

    # install knot-resolver-manager
    pushd manager
    python -Pm installer --destdir="$pkgdir" dist/*.whl
    install -m 644 -D etc/knot-resolver/config.yaml ${pkgdir}/etc/knot-resolver/config.yaml
    install -m 644 -D shell-completion/client.bash ${pkgdir}/usr/share/bash-completion/completions/kresctl
    install -m 644 -D shell-completion/client.fish ${pkgdir}/usr/share/fish/completions/kresctl.fish
    popd

}
